﻿Imports System.IO
Imports System.Net

Public Class FTPDownload
    Private PvCS_FoldName As String
    Private Sub Btn_Dir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Dir.Click
        Dim folderDlg As New FolderBrowserDialog
        folderDlg.ShowNewFolderButton = True
        If (folderDlg.ShowDialog() = DialogResult.OK) Then
            TxtDownloadPath.Text = folderDlg.SelectedPath
            PvCS_FoldName = TxtDownloadPath.Text
            Dim root As Environment.SpecialFolder = folderDlg.RootFolder
        End If
    End Sub
    Private Sub Btn_Download_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Download.Click
        'Values to use
        Dim localFile As String = PvCS_FoldName + "\" + TxtDownFileName.Text
        Dim remoteFile As String = "/" + TxtDownFileName.Text
        Dim host As String = TxtFTPSite.Text
        Const username As String = ""
        Const password As String = ""

        '1. Create a request: must be in ftp://hostname format, 
        '   not just ftp.myhost.com
        Dim URI As String = host & remoteFile
        Dim ftp As System.Net.FtpWebRequest = _
            CType(FtpWebRequest.Create(URI), FtpWebRequest)

        '2. Set credentials
        ftp.Credentials = New  _
            System.Net.NetworkCredential(username, password)

        '3. Settings and action
        ftp.KeepAlive = False
        'we want a binary transfer, not textual data
        ftp.UseBinary = True
        'Define the action required (in this case, download a file)
        ftp.Method = System.Net.WebRequestMethods.Ftp.DownloadFile

        '4. If we were using a method that uploads data e.g. UploadFile
        '   we would open the ftp.GetRequestStream here an send the data

        '5. Get the response to the Ftp request and the associated stream
        Using response As System.Net.FtpWebResponse = _
              CType(ftp.GetResponse, System.Net.FtpWebResponse)
            Using responseStream As IO.Stream = response.GetResponseStream
                'loop to read & write to file
                Using fs As New IO.FileStream(localFile, IO.FileMode.Create)
                    Dim buffer(2047) As Byte
                    Dim read As Integer = 0
                    Do
                        read = responseStream.Read(buffer, 0, buffer.Length)
                        fs.Write(buffer, 0, read)
                    Loop Until read = 0 'see Note(1)
                    responseStream.Close()
                    fs.Flush()
                    fs.Close()
                End Using
                responseStream.Close()
            End Using
            response.Close()
        End Using

        '6. Done! the Close happens because ftp goes out of scope
        '   There is no .Close or .Dispose for FtpWebRequest
    End Sub
End Class